diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/csma/bindings/modulegen__gcc_LP64.py ns-3.36/src/csma/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/csma/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/csma/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.810733300 -0700
@@ -6993,11 +7017,11 @@
     cls.add_method('Attach', 
                    'bool', 
                    [param('ns3::Ptr< ns3::CsmaChannel >', 'ch')])
-    ## csma-net-device.h (module 'csma'): void ns3::CsmaNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet> > queue) [member function]
+    ## csma-net-device.h (module 'csma'): void ns3::CsmaNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet>> queue) [member function]
     cls.add_method('SetQueue', 
                    'void', 
                    [param('ns3::Ptr< ns3::Queue< ns3::Packet > >', 'queue')])
-    ## csma-net-device.h (module 'csma'): ns3::Ptr<ns3::Queue<ns3::Packet> > ns3::CsmaNetDevice::GetQueue() const [member function]
+    ## csma-net-device.h (module 'csma'): ns3::Ptr<ns3::Queue<ns3::Packet>> ns3::CsmaNetDevice::GetQueue() const [member function]
     cls.add_method('GetQueue', 
                    'ns3::Ptr< ns3::Queue< ns3::Packet > >', 
                    [], 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/csma/CMakeLists.txt ns-3.36/src/csma/CMakeLists.txt
--- ns-3.35/src/csma/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/csma/CMakeLists.txt	2022-04-30 18:23:57.810733300 -0700
@@ -0,0 +1,15 @@
+build_lib(
+  LIBNAME csma
+  SOURCE_FILES
+    helper/csma-helper.cc
+    model/backoff.cc
+    model/csma-channel.cc
+    model/csma-net-device.cc
+  HEADER_FILES
+    helper/csma-helper.h
+    model/backoff.h
+    model/csma-channel.h
+    model/csma-net-device.h
+  LIBRARIES_TO_LINK ${libnetwork}
+  TEST_SOURCES ${test_sources}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/csma/examples/CMakeLists.txt ns-3.36/src/csma/examples/CMakeLists.txt
--- ns-3.35/src/csma/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/csma/examples/CMakeLists.txt	2022-04-30 18:23:57.814733300 -0700
@@ -0,0 +1,39 @@
+set(base_examples
+    csma-one-subnet
+    csma-broadcast
+    csma-packet-socket
+    csma-multicast
+)
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK
+      ${libcsma}
+      ${libinternet}
+      ${libapplications}
+  )
+endforeach()
+
+build_lib_example(
+  NAME csma-raw-ip-socket
+  SOURCE_FILES csma-raw-ip-socket.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+    ${libinternet-apps}
+)
+
+build_lib_example(
+  NAME csma-ping
+  SOURCE_FILES csma-ping.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+    ${libinternet-apps}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/csma/helper/csma-helper.cc ns-3.36/src/csma/helper/csma-helper.cc
--- ns-3.35/src/csma/helper/csma-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/csma/helper/csma-helper.cc	2022-04-30 18:23:57.814733300 -0700
@@ -44,6 +44,7 @@
   m_queueFactory.SetTypeId ("ns3::DropTailQueue<Packet>");
   m_deviceFactory.SetTypeId ("ns3::CsmaNetDevice");
   m_channelFactory.SetTypeId ("ns3::CsmaChannel");
+  m_enableFlowControl = true;
 }
 
 void 
@@ -74,6 +75,12 @@
   m_channelFactory.Set (n1, v1);
 }
 
+void
+CsmaHelper::DisableFlowControl (void)
+{
+  m_enableFlowControl = false;
+}
+
 void 
 CsmaHelper::EnablePcapInternal (std::string prefix, Ptr<NetDevice> nd, bool promiscuous, bool explicitFilename)
 {
@@ -310,11 +317,13 @@
   Ptr<Queue<Packet> > queue = m_queueFactory.Create<Queue<Packet> > ();
   device->SetQueue (queue);
   device->Attach (channel);
-  // Aggregate a NetDeviceQueueInterface object
-  Ptr<NetDeviceQueueInterface> ndqi = CreateObject<NetDeviceQueueInterface> ();
-  ndqi->GetTxQueue (0)->ConnectQueueTraces (queue);
-  device->AggregateObject (ndqi);
-
+  if (m_enableFlowControl)
+    {
+      // Aggregate a NetDeviceQueueInterface object
+      Ptr<NetDeviceQueueInterface> ndqi = CreateObject<NetDeviceQueueInterface> ();
+      ndqi->GetTxQueue (0)->ConnectQueueTraces (queue);
+      device->AggregateObject (ndqi);
+    }
   return device;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/csma/helper/csma-helper.h ns-3.36/src/csma/helper/csma-helper.h
--- ns-3.35/src/csma/helper/csma-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/csma/helper/csma-helper.h	2022-04-30 18:23:57.814733300 -0700
@@ -91,6 +91,16 @@
   void SetChannelAttribute (std::string n1, const AttributeValue &v1);
 
   /**
+   * Disable flow control only if you know what you are doing. By disabling
+   * flow control, this NetDevice will be sent packets even if there is no
+   * room for them (such packets will be likely dropped by this NetDevice).
+   * Also, any queue disc installed on this NetDevice will have no effect,
+   * as every packet enqueued to the traffic control layer queue disc will
+   * be immediately dequeued.
+   */
+  void DisableFlowControl (void);
+
+  /**
    * This method creates an ns3::CsmaChannel with the attributes configured by
    * CsmaHelper::SetChannelAttribute, an ns3::CsmaNetDevice with the attributes
    * configured by CsmaHelper::SetDeviceAttribute and then adds the device
@@ -250,6 +260,7 @@
   ObjectFactory m_queueFactory;   //!< factory for the queues
   ObjectFactory m_deviceFactory;  //!< factory for the NetDevices
   ObjectFactory m_channelFactory; //!< factory for the channel
+  bool m_enableFlowControl;       //!< whether to enable flow control
 };
 
 } // namespace ns3
